#!/bin/bash

# Global test result (default = 0 : ok)
export GLOBALRES=0

VERBOSE=
while getopts v OPTION
do
case $OPTION in
    v) VERBOSE=yes ;;
esac
done

TMPFILE="/tmp/file-$$"

function vim_test {
    # Subtest - test that vim does not clear audit attrs in $HOME
    echo -n `gettext "Use vim to edit file "`$HOMEFILE"..." 1>&2
    HOMEFILE=~/__audit_file_test.$$
    echo "test" > $HOMEFILE
    setfaud -m o:o $HOMEFILE
    echo -ne "a1234\e:wq\n" | vim -n $HOMEFILE > /dev/null 2> /dev/null
    fcontent=`cat $HOMEFILE`
    fattrs=`getfaud -c $HOMEFILE 2> /dev/null`
    if [ "$fcontent" != "t1234est" ] || [ "$fattrs" != "o:o:o" ]; then
        echo `gettext "vim file edit test failed"` 1>&2
        echo `gettext "FAIL"` 1>&2
        GLOBALRES=1
    else
      echo `gettext "PASS"` 1>&2
    fi
    rm -f $HOMEFILE

    # Subtest - test that vim does not clear audit attrs in /tmp
    echo -n `gettext "Use vim to edit file "`$TMPFILE"..." 1>&2
    echo "test" > $TMPFILE
    setfaud -m o:o $TMPFILE
    echo -ne "a1234\e:set backupskip=\n:wq\n" | vim -n $TMPFILE > /dev/null 2> /dev/null
    fcontent=`cat $TMPFILE`
    fattrs=`getfaud -c $TMPFILE 2> /dev/null`
    if [ "$fcontent" != "t1234est" ] || [ "$fattrs" != "o:o:o" ]; then
        echo `gettext "vim file edit test failed"` 1>&2
        echo `gettext "FAIL"` 1>&2
        GLOBALRES=1
    else
      echo `gettext "PASS"` 1>&2
    fi

    rm -f $TMPFILE
}

if [[ $(uname -r) =~ ^5\. ]]; then
    python3 audit_file.py
    if [ ! $? -eq 0 ]; then
        echo `gettext "FAIL"` 1>&2
        GLOBALRES=1
    else
        echo `gettext "PASS"` 1>&2
    fi
    vim_test
    exit $GLOBALRES
fi
