#!/bin/bash

TESTUSER="audittestuser"	#testuser
TMPFILE="/tmp/file-$$"	#testfile
export GLOBALRES="0"	#global result


VERBOSE=
while getopts v OPTION
do
case $OPTION in
    v) VERBOSE=yes ;;
esac
done

function cleanup() {
    rm -f $TMPFILE ${TMPFILE}2 ${TMPFILE}3
    usercaps -d $TESTUSER
    deluser -q --remove-home  $TESTUSER
    useraud -d root
    mv /etc/parsec/audit.bak /etc/parsec/audit
}

if [[ $(uname -r) =~ ^5\. ]]; then
    python3 audit_proc.py
    if [ ! $? -eq 0 ]; then
        echo `gettext "FAIL"` 1>&2
        GLOBALRES=1
    else
        echo `gettext "PASS"` 1>&2
    fi
    cleanup
    exit $GLOBALRES
fi
