#!/bin/bash

MAXILEV=`cat /sys/module/parsec/parameters/max_ilev`
TESTDIR_PATH=${TESTDIR_PATH:-"/parsec_testdir"}
SD_SERVICE=mictest_bogusd
export GLOBALRES="0"	#global result

if [ "$1" = "-v" ]; then export VERBOSE=1; fi

#test1 - file access
set -e
if [ -z "$MAXILEV" ]; then
	echo "max_ilev detect failed"
	exit 1
fi
rm -rf $TESTDIR_PATH
mkdir -p $TESTDIR_PATH
pdpl-file :$MAXILEV $TESTDIR_PATH
mkdir -p $TESTDIR_PATH/mic
pdpl-file :$MAXILEV:0:ccnri $TESTDIR_PATH/mic
set +e
./mictest -files $TESTDIR_PATH/mic
GLOBALRES=$(($GLOBALRES + $?))


#test5 - IGNMACINT privilege effect test
./mictest -ignmacint $TESTDIR_PATH/mic
GLOBALRES=$(($GLOBALRES + $?))


#cleanup
rm -rf $TESTDIR_PATH


#test2 - signal permissions
./mictest -signals
GLOBALRES=$(($GLOBALRES + $?))


#test4 - mic level change
./mictest -ilevchange
GLOBALRES=$(($GLOBALRES + $?))


#test5a - IGNMACINT privilege acquirement test
./mictest -miccap
GLOBALRES=$(($GLOBALRES + $?))


#test3 - systemd control
lev=$MAXILEV
rm -f /run/systemd/system/$SD_SERVICE.service
systemctl daemon-reload
while true; do
	echo "[Unit]
	Description=Bogus daemon for MIC test
	[Service]
	StartLimitBurst=0
	Type=simple
	ExecStart=$PWD/mictest -bogusd
	PDPLabel=:$lev" > /run/systemd/system/$SD_SERVICE.service
	systemctl daemon-reload
	sg astra-admin "./mictest -systemd $SD_SERVICE $lev"
	GLOBALRES=$(($GLOBALRES + $?))
	if [ $lev -eq 0 ]; then break; fi
	lev=$(($lev / 2));
done
rm -f /run/systemd/system/$SD_SERVICE.service
systemctl daemon-reload


exit $GLOBALRES
