#!/bin/bash

IPV4_CONFIG_PATH=/proc/sys/net/ipv4/
IPV4_SETTINGS="tcp_syn_retries"
IPV4_NEW_SETTINGS="1"
IPV4_SAVED_SETTINGS=""

function save_v4_settings()
{
	local s
	for s in $IPV4_SETTINGS
	do
		IPV4_SAVED_SETTINGS="$IPV4_SAVED_SETTINGS `cat $IPV4_CONFIG_PATH/$s`"
	done
}

function set_v4_settings()
{
	local s
	set $IPV4_NEW_SETTINGS
	for s in $IPV4_SETTINGS
	do
		echo $1 > $IPV4_CONFIG_PATH/$s
		shift
	done	
}

function restore_v4_settings()
{
	local s
	set $IPV4_SAVED_SETTINGS
	for s in $IPV4_SETTINGS
	do
		echo $1 > $IPV4_CONFIG_PATH/$s
		shift
	done
}
save_v4_settings
set_v4_settings
./tcpip6_mac $1 $2 $3
result=$?
restore_v4_settings
exit $result
